Attribute VB_Name = "modCompTransLate"
Option Explicit

Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Dim ResFileName As String

Public Sub SetResFileName(FileName As String)
  ResFileName = FileName
End Sub


Public Sub LoadAllName(frm As Form)
  Dim Obj As Object
  Dim strTemp As String
  Dim ObjName As String
  Dim SubObjName As String
  Dim ObjIndex As Integer
  Dim lPnt As Long
  Dim SavObjTab  As Integer
  If ResFileName = "" Then
    ResFileName = App.Path & "\" & App.Title & ".lng"
  End If
  On Error Resume Next
  frm.Caption = ReadIniFile(ResFileName, frm.Name, "Form.Caption", frm.Caption)
  For Each Obj In frm
    Err.Clear
    ObjIndex = Obj.Index
    If Err.Number <> 0 Then ' if the object is not indexed
      ObjName = Obj.Name
    Else        ' if the object is indexed
      ObjName = Obj.Name & "(" & CStr(ObjIndex) & ")"
    End If
    If TypeOf Obj Is SSTab Then
      For lPnt = 0 To Obj.Tabs - 1
        SubObjName = "|" & CStr(lPnt)
        Obj.TabCaption(lPnt) = ReadIniFile(ResFileName, frm.Name, ObjName & SubObjName & ".Caption", Obj.TabCaption(lPnt))
      Next
    ElseIf TypeOf Obj Is TabStrip Then
      For lPnt = 0 To Obj.Tabs.Count - 1
        SubObjName = "|" & CStr(lPnt)
        Obj.Tabs(lPnt).Caption = ReadIniFile(ResFileName, frm.Name, ObjName & SubObjName & ".Caption", Obj.Tabs(lPnt).Caption)
        Obj.Tabs(lPnt).ToolTipText = ReadIniFile(ResFileName, frm.Name, ObjName & SubObjName & ".ToolTipText", Obj.Tabs(lPnt).ToolTipText)
      Next
    Else
      Obj.Caption = ReadIniFile(ResFileName, frm.Name, ObjName & ".Caption", Obj.Caption)
      Obj.ToolTipText = ReadIniFile(ResFileName, frm.Name, ObjName & ".ToolTipText", Obj.ToolTipText)
    End If
  Next

End Sub

Public Function LoadName(Id As Long) As String
  If ResFileName = "" Then
    ResFileName = App.Path & "\" & App.Title & ".lng"
  End If
  LoadName = ReadIniFile(ResFileName, "MSG", "msg" & CStr(Id))
End Function

Private Function WriteIniFile(strIniFile As String, _
                              strSection As String, _
                              strKey As String, _
                              Value As String) As Long
  Dim strTemp As String
  strTemp = Replace(Value, vbCrLf, "|")
  WriteIniFile = WritePrivateProfileString(strSection, strKey, strTemp, strIniFile)
End Function
Private Function ReadIniFile(strIniFile As String, _
                     strSection As String, _
                     strKey As String, _
                     Optional strDefault As String) As String
  Dim Buffer As String
  Dim lRet As Integer
  Buffer = String(255, Chr(0))
  lRet = GetPrivateProfileString(strSection, strKey, strDefault, Buffer, Len(Buffer), strIniFile)
  Buffer = Left$(Buffer, lRet)
  Buffer = Replace(Buffer, "~", vbCrLf)
  ReadIniFile = Buffer
End Function

