Attribute VB_Name = "modEnumRes"
Option Explicit
Dim hLib As Long  'handle sur le module charg
Dim strRessources As String

Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Private Declare Function LoadLibraryEx Lib "kernel32" Alias "LoadLibraryExA" (ByVal lpLibFileName As String, ByVal hFile As Long, ByVal dwFlags As Long) As Long
Private Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long

Private Declare Function EnumResourceTypes Lib "kernel32" Alias "EnumResourceTypesA" (ByVal hModule As Long, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function EnumResourceNames Lib "kernel32" Alias "EnumResourceNamesA" (ByVal hModule As Long, ByVal lpType As Any, ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Private Declare Function LoadString Lib "user32" Alias "LoadStringA" (ByVal hInstance As Long, ByVal wID As Long, ByVal lpBuffer As String, ByVal nBufferMax As Long) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pTo As Any, uFrom As Any, ByVal lSize As Long)
Private Declare Function lstrlenA Lib "kernel32" (ByVal lpString As Long) As Long


' Predefined Resource Types
Private Enum ResTypes
   RT_CURSOR = 1&
   RT_BITMAP = 2&
   RT_ICON = 3&
   RT_MENU = 4&
   RT_DIALOG = 5&
   RT_STRING = 6&
   RT_FONTDIR = 7&
   RT_FONT = 8&
   RT_ACCELERATOR = 9&
   RT_RCDATA = 10&
   RT_MESSAGETABLE = 11&
   RT_GROUP_CURSOR = 12&
   RT_GROUP_ICON = 14&
   RT_VERSION = 16&
   RT_DLGINCLUDE = 17&
   RT_PLUGPLAY = 19&
   RT_VXD = 20&
   RT_ANICURSOR = 21&
   RT_ANIICON = 22&
   RT_HTML = 23&
End Enum

Public Function ExtractStrings(FileName As String) As String
  'la fonction retourne un string
  'chaques ressources seront spares par un vbCrLf
  'le n et le libell seront separs par un vbtab
  '===============================================
  'chargement du module
  If Not LoadResFile(FileName) Then
    ExtractStrings = vbTab & "Impossible de charger ce module"
    Exit Function
  End If
  
  EnumResourcesEx (FileName)
  
  ExtractStrings = Ressource
  'MsgBox "Load ok"
  
  'dechargement du module
  UnloadResFile
End Function

Private Function Ressource() As String
  Ressource = strRessources
End Function

Private Function LoadResFile(FileName As String) As Boolean
  UnloadResFile
  On Error Resume Next
  hLib = LoadLibrary(FileName)
  On Error GoTo 0
  If hLib = 0 Then
    LoadResFile = False
  Else
    LoadResFile = True
  End If
End Function
Private Sub UnloadResFile()
  If hLib <> 0 Then
    FreeLibrary hLib
    hLib = 0
  End If
End Sub

Private Sub EnumResourcesEx(FileName As String)
  strRessources = ""
  Call EnumResourceTypes(hLib, AddressOf EnumResTypeProc, 0&)
End Sub

Private Function EnumResTypeProc(ByVal hModule As Long, ByVal lpszType As Long, ByVal lParam As Long) As Long
   'BOOL CALLBACK EnumResTypeProc(
   '    HANDLE hModule,  // resource-module handle
   '    LPTSTR lpszType, // pointer to resource type
   '    LONG lParam   // application-defined parameter
   '   );
   Dim ResType As String
   ' Retrieve type or custom name of resource.
   ResType = DecodeResTypeName(lpszType)
   'Debug.Print "Type de ressource : "; ResTypeName(lpszType); " (" & ResType & ")"
   ' Enumerate resource names of this type.
   If lpszType = RT_STRING Then
    Call EnumResourceNames(hModule, lpszType, AddressOf EnumResNameProc, lParam)
   End If
   ' Continue enumeration...
   EnumResTypeProc = True
End Function

Private Function EnumResNameProc(ByVal hModule As Long, ByVal lpszType As Long, ByVal lpszName As Long, ByVal lParam As Long) As Long
   'BOOL CALLBACK EnumResNameProc(
   '    HANDLE hModule,  // resource-module handle
   '    LPCTSTR lpszType,   // pointer to resource type
   '    LPTSTR lpszName, // pointer to resource name
   '    LONG lParam   // application-defined parameter
   '   );
   Dim ResName As String
   Dim ResType As String
   Dim Buffer As String
   Dim nRet As Long
   Dim lPnt As Long
   
   ' Retrieve resource ID.
   ResType = DecodeResTypeName(lpszType)
   ResName = DecodeResTypeName(lpszName)
   'Debug.Print ResType; "   --> "; ResName
   
   If lpszType = RT_STRING Then
      Debug.Print "Groupe " & ResName
      ' We have a block of 16 strings for this entry.
      ' Must determine which are valid.
      If Not HiWord(lpszName) Then
         ' Allocate a good-sized buffer.
         Buffer = Space$(255)
         For lPnt = ((lpszName - 1) * 16) To (lpszName * 16) - 1
            nRet = LoadString(hModule, lPnt, Buffer, Len(Buffer))
            If nRet Then
               Debug.Print "   ----> "; "#" & CStr(lPnt) & "  (""" & Left$(Buffer, nRet) & """)"
               strRessources = strRessources & CStr(lPnt) & vbTab & Left$(Buffer, nRet) & vbCrLf
            End If
         Next lPnt
      End If
      
   Else
    'Debug.Print "   "; ResName, ResType
      ' Alert client. Continue enum by default.
   End If

   ' Continue enumeration...
   EnumResNameProc = True
End Function
Private Function DecodeResTypeName(ByVal lpszValue As Long) As String
   If HiWord(lpszValue) Then
      ' Pointers will always be >64K
      DecodeResTypeName = PointerToStringA(lpszValue)
   Else
      ' Otherwise we have an ID.
      DecodeResTypeName = "#" & CStr(lpszValue)
   End If
End Function

Private Function ResTypeName(ByVal ResType As ResTypes) As String
   Select Case ResType
      Case RT_ACCELERATOR
         ResTypeName = "Accelerator table"
      Case RT_ANICURSOR
         ResTypeName = "Animated cursor"
      Case RT_ANIICON
         ResTypeName = "Animated icon"
      Case RT_BITMAP
         ResTypeName = "Bitmap resource"
      Case RT_CURSOR
         ResTypeName = "Hardware-dependent cursor resource"
      Case RT_DIALOG
         ResTypeName = "Dialog box"
      Case RT_DLGINCLUDE
         ResTypeName = "Header file that contains menu and dialog box #define statements"
      Case RT_FONT
         ResTypeName = "Font resource"
      Case RT_FONTDIR
         ResTypeName = "Font directory resource"
      Case RT_GROUP_CURSOR
         ResTypeName = "Hardware-independent cursor resource"
      Case RT_GROUP_ICON
         ResTypeName = "Hardware-independent icon resource"
      Case RT_HTML
         ResTypeName = "HTML document"
      Case RT_ICON
         ResTypeName = "Hardware-dependent icon resource"
      Case RT_MENU
         ResTypeName = "Menu resource"
      Case RT_MESSAGETABLE
         ResTypeName = "Message-table entry"
      Case RT_PLUGPLAY
         ResTypeName = "Plug and play resource"
      Case RT_RCDATA
         ResTypeName = "Application-defined resource (raw data)"
      Case RT_STRING
         ResTypeName = "String-table entry"
      Case RT_VERSION
         ResTypeName = "Version resource"
      Case RT_VXD
         ResTypeName = "VXD"
      Case Else
         ResTypeName = "User-defined custom resource"
   End Select
End Function

Private Property Get HiWord(LongIn As Long) As Integer
   Call CopyMemory(HiWord, ByVal (VarPtr(LongIn) + 2), 2)
End Property

Private Function PointerToStringA(lpStringA As Long) As String
   Dim Buffer() As Byte
   Dim nLen As Long
   
   If lpStringA Then
      nLen = lstrlenA(ByVal lpStringA)
      If nLen Then
         ReDim Buffer(0 To (nLen - 1)) As Byte
         CopyMemory Buffer(0), ByVal lpStringA, nLen
         PointerToStringA = StrConv(Buffer, vbUnicode)
      End If
   End If
End Function


